#!/usr/bin/perl

# bunny-server - Backend and web frontend for searching in the Debian bugs
# database
#
# Copyright (C) 2011 Julien Vaubourg <julien@vaubourg.com>
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


#####
# THIS IS JUST A DRAFT
#####


use strict;
use JSON -support_by_pp;
use WWW::Mechanize;


########## CONFIGURE:BEGIN ##########

# Path of the Xapian db
my $database_path = "./db";

########### CONFIGURE:END ###########


print "Content-type: text/html\r\n\r\n";

if($ENV{QUERY_STRING} =~ /completion=([^&]+)/) {
	my $completion = lc $1;
	my @choices;
	my @suggestions;

	$completion =~ s/\%([a-f0-9]{2})/pack('C', hex($1))/segi;

	if($completion =~ /^package:(.*)/) {
		my $word = $1;

		open(my $PACKAGES, '<', "$database_path/packages")
		or die "Couldn't open $database_path/packages!";

		while (<$PACKAGES>) {
			chomp;

			push(@suggestions, {
				"label" => $_,
				"value" => "package:$_"
			}) if $word eq '' || /$word/i;

			close($PACKAGES) if @suggestions > 11;
		}

		close $PACKAGES if <$PACKAGES>;

	} elsif($completion =~ /^owner:(.*)/) {
		my $word = $1;

		open(my $OWNERS, '<', "$database_path/owners")
		or die "Couldn't open $database_path/owners!";

		while (<$OWNERS>) {
			chomp;
			chop;

			push(@suggestions, {
				"label" => $_,
				"value" => "owner:\"$_\" "
			}) if $word eq '' || /$word/i;

			close($OWNERS) if @suggestions > 11;
		}

		close $OWNERS if <$OWNERS>;


	} elsif($completion =~ /^severity:(.*)/) {
		my $word = $1;

		for (qw(wishlist minor normal important serious grave critical)) {
			push(@suggestions, {
				"label" => $_,
				"value" => "severity:$_ "
			}) if $word eq '' || /$word/i;
		}

	} elsif($completion =~ /^wnpp:(.*)/) {
		my $word = $1;

		for (qw(ITA ITP O RFA RFH RFP)) {
			push(@suggestions, {
				"label" => $_,
				"value" => "wnpp:$_ "
			}) if $word eq '' || /$word/i
		}

	} elsif($completion =~ /^tag:(.*)/) {
		my $word = $1;

		for (qw(patch wontfix moreinfo unreproductible help pending
			security upstream confirmed fixed fixed d ipv6 lfs l10n potato woody sarge
			sarge-ignore etch etch-ignore lenny lenny-ignore squeeze squeeze-ignore wheezy
			wheezy-ignore sid experimental)) {

			push(@suggestions, {
				"label" => $_,
				"value" => "tag:$_ "
			}) if $word eq '' || /$word/i;
		}

	} else {
		for (qw(owner: doneby: package: subject: version: id: wnpp: tag: severity: AND OR NOT)) {
			push(@suggestions, {
				"label" => $_,
				"value" => "$_"
			}) if $completion eq '' || /^$completion/i;
		}
	}

	my $browser = WWW::Mechanize->new();

	$browser->get("http://localhost/gt");
	my $content = $browser->content();

	my $json = new JSON;
	my %result = %{
		$json->allow_nonref->utf8->relaxed->escape_slash->loose->allow_singlequote->allow_barekey->decode($content)
	};

	my $json = JSON->new->allow_nonref;
	my $json_string = $json->encode(\@suggestions);

	print $json_string;

} elsif($ENV{QUERY_STRING} =~ /q=([^&]+)/) {
	my $query = $1;
	$query =~ s/\%([a-f0-9]{2})/pack('C', hex($1))/segi;

	my $content = `bunny-server.pl $query`;
	my $json = new JSON;
	my %result = %{
		$json->allow_nonref->utf8->relaxed->escape_slash->loose->allow_singlequote->allow_barekey->decode($content)
	};

	open(my $TPL, "bunny-webfrontend.tpl")
	or die "Couldn't open bunny-webfrontend.tpl!";

	while (<$TPL>) {
		s/<TPL:QUERY>/$query/;

		print;
	}

	close $TPL;

} else {

	open(my $TPL, "bunny-webfrontend.tpl")
	or die "Couldn't open bunny-webfrontend.tpl!";

	while (<$TPL>) {
		s/<TPL:QUERY>//;
		print;
	}

	close $TPL;
}

exit 0;


